<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractBootLoaderGen xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/transformations/AbstractBootLoaderGen.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.transformations;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.Comparator;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> java.util.Stack;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.InitPrecedence;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.AllocUtils;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoCDP;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.library.Messages;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.ConnectorUtil;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Connector;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectorEnd;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InterfaceRealization;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.OpaqueBehavior;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuralFeature;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ValueSpecification;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment"> * The task of the boot-loader is twofold: create the instances of all</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment"> * implementations (non-recursive).</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment"> * - create Connections: what should be done?</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment"> * TODO: factor out common code (TemplateInstantiation mechanism &amp; createConnections below)</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment"> * Split between C++ specific and C++ independent aspects</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/transformations/AbstractBootLoaderGen.html">AbstractBootLoaderGen</a> <strong class="jxr_keyword">implements</strong> IM2MTrafoCDP {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SYSINTERFACES_ISTART = <span class="jxr_string">"sysinterfaces::IStart"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String INIT_OP = <span class="jxr_string">"init"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String I_LIFE_CYCLE = <span class="jxr_string">"ILifeCycle"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String EMPTYSTR = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String NODE_INFO = <span class="jxr_string">"NodeInfo"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String NL = <span class="jxr_string">"\n"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String EOL = <span class="jxr_string">";\n"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 * language specific initialization code</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> languageInit();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">	 * language specific activation</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * @param activationKeys set of keys </em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageActivation(Class[] activationKeys);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageDeactivation(Class[] activationKeys);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageDefaultExecCode();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageCreateInstance(InstanceSpecification is, Class implementation);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageCreateConn(String varName);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageRunStart(String varName, <strong class="jxr_keyword">boolean</strong> useOO);
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> String languageAssignRef(String accessName, String referenceVarName);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	 
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 * Create a new boot-loader in a specific package</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 * (which represents a node of the system).</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">	 * @param copier a lazy copier</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 * @param nodeIndex the index of the node</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 * @param numberOfNodes the number of nodes</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> init(LazyCopier copier, <strong class="jxr_keyword">int</strong> nodeIndex, <strong class="jxr_keyword">int</strong> numberOfNodes)
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<em class="jxr_comment">// m_bootLoader = TransformationContext.current.modelRoot.createOwnedClass(BOOTLOADER_NAME, false);</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		outputSizeof = false;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		m_copier = copier;
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		m_initCode = EMPTYSTR;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		m_initCodeRun = EMPTYSTR;
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		m_activation = <strong class="jxr_keyword">new</strong> HashMap&lt;Class, EList&lt;String&gt;&gt;();
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		m_initCodeCConnections = EMPTYSTR;
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		m_initCodeCConfig = EMPTYSTR;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<em class="jxr_comment">// indexMap = new HashMap&lt;String, Integer&gt;();</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 	}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 * Return the path from the main instance towards a sub-instance using the proper dereference</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 * operators (only relevant in case of C++)</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> <em class="jxr_javadoccomment">	 * @param slotPath</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_javadoccomment">	 * @param accessName</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_javadoccomment">	 *            return the name to access the feature. Returns access path to instance, not</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_javadoccomment">	 *            the name of the variable for this instance (if instantiated by bootloader)</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 	<strong class="jxr_keyword">public</strong> String getPath(Stack&lt;Slot&gt; slotPath, InstanceSpecification instance, <strong class="jxr_keyword">boolean</strong> accessName) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<strong class="jxr_keyword">if</strong> (slotPath.size() &gt; 0) {
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			<em class="jxr_comment">// start with first instance</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			String path = slotPath.get(0).getOwningInstance().getName();
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			<strong class="jxr_keyword">boolean</strong> previousInstantiatedByBL = false;
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 			<strong class="jxr_keyword">for</strong> (Slot pathElement : slotPath) {
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 				<strong class="jxr_keyword">if</strong> (pathElement != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 					<strong class="jxr_keyword">if</strong> (previousInstantiatedByBL &amp;&amp; accessName) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 						<em class="jxr_comment">// If an instance is instantiated by the bootloader, it is only referenced via its type in the</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 						<em class="jxr_comment">// owning composite. Thus, configuration (and activation calls) might fail as the type might not</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 						<em class="jxr_comment">// have these configuration properties or operations.</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 						<em class="jxr_comment">// Therefore, configuration and initial calls use</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 						<em class="jxr_comment">// - the path, if instantiated by the composite</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 						<em class="jxr_comment">// - the variable name, if done by the bootloader</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 						path = ElementUtils.varName(path); <em class="jxr_comment">// use variable name instead.</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 					}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 					path += <span class="jxr_string">"."</span> + pathElement.getDefiningFeature().getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 					previousInstantiatedByBL = instantiateViaBootloader(pathElement.getDefiningFeature());
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 				}
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			}
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			<strong class="jxr_keyword">if</strong> (previousInstantiatedByBL &amp;&amp; !accessName) {
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 				<em class="jxr_comment">// name of the variable for this expression instantiated by the bootloader</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 				path = ElementUtils.varName(path);
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			<strong class="jxr_keyword">return</strong> path;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			<strong class="jxr_keyword">return</strong> instance.getName(); <em class="jxr_comment">// instance has no path via slots, it is a top level instance</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		}
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 	}
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> <em class="jxr_javadoccomment">	 * Check whether the passed implementation has an unconnected start port.</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> <em class="jxr_javadoccomment">	 * This information is required, since only unconnected start ports are automatically called by the</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> <em class="jxr_javadoccomment">	 * bootloader, in particular we want to avoid calling a start port of an executor (which is connected)</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> <em class="jxr_javadoccomment">	 * and its container.</em>
<a class="jxr_linenumber" name="L171" href="#L171">171</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * @param implementation</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 * @param containerSlot</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> hasUnconnectedStartRoutine(LazyCopier copier, Class implementation, Slot containerSlot) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 		Port startPort = AllocUtils.getStartPort(implementation);
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		<strong class="jxr_keyword">if</strong> (startPort != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			<strong class="jxr_keyword">return</strong> !isConnected(copier, containerSlot, startPort);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		}
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 	
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> implementsIStart(Class implementation) {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		Port startPort = AllocUtils.getStartPort(implementation);
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		<strong class="jxr_keyword">if</strong> (startPort == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			<em class="jxr_comment">// OO case</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			<strong class="jxr_keyword">for</strong> (InterfaceRealization ir : implementation.getInterfaceRealizations()) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 				<strong class="jxr_keyword">if</strong> (ir.getContract().getQualifiedName().equals(SYSINTERFACES_ISTART)) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 					<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			}
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * Check, if the passed implementation has an unconnected life-cycle interface (activate/deactivate).</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 * This information is required, since only unconnected life cycle ports are automatically called by the</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 * bootloader, in particular we want to avoid calling a life cycle port of an executor (which is connected)</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * and its container.</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 * @param implementation</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> hasUnconnectedLifeCycle(LazyCopier copy, Class implementation, Slot containerSlot) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		<strong class="jxr_keyword">if</strong> (implementation != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 			Element lcPortElem = ElementUtils.getNamedElementFromList(implementation.getAllAttributes(), <span class="jxr_string">"lc"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			<strong class="jxr_keyword">if</strong> (lcPortElem instanceof Port) {
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 				Port lcPort = (Port) lcPortElem;
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 				<em class="jxr_comment">// check, if port typed with ILifeCycle interface</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 				<strong class="jxr_keyword">if</strong> (lcPort.getType().getName().equals(I_LIFE_CYCLE)) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 					<strong class="jxr_keyword">return</strong> !isConnected(copy, containerSlot, lcPort);
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 				}
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 			}
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		}
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 	}
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> <em class="jxr_javadoccomment">	 * The check verifies whether the passed port is connected within</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> <em class="jxr_javadoccomment">	 * the context of the composite represented by the passed slot</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> <em class="jxr_javadoccomment">	 * @param containerSlot</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 *            a slot within an instance that represents a composite class</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 * @Param a port that is checked for being connected</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 * @return true, if connected</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isConnected(LazyCopier copier, Slot containerSlot, Port port) {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<strong class="jxr_keyword">if</strong> (containerSlot != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			StructuralFeature sf = containerSlot.getDefiningFeature();
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			<strong class="jxr_keyword">if</strong> (sf instanceof Property) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 				Property part = (Property) sf;
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 				Class composite = part.getClass_();
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 				<strong class="jxr_keyword">for</strong> (Connector connector : composite.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 					<em class="jxr_comment">// must assure same connector end connects part &amp; port</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 					ConnectorEnd end = ConnectorUtil.connEndForPart(connector, part);
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 					<strong class="jxr_keyword">if</strong> ((end != <strong class="jxr_keyword">null</strong>) &amp;&amp; (end.getRole() == port)) {
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 						<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 					}
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 				}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 			}
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		}
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 	}
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 * Add the configuration code for an instance</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_javadoccomment">	 * @param slotPath</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L253" href="#L253">253</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L254" href="#L254">254</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> instanceConfig(Stack&lt;Slot&gt; slotPath, InstanceSpecification instance) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		Slot slot = slotPath.peek();
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 		<em class="jxr_comment">// String varName = getPath(slotPath, instance, false);</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 		StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		<strong class="jxr_keyword">if</strong> (sf == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(<span class="jxr_string">"A slot for instance %s has no defining feature"</span>, instance.getName())); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		}
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 		String varName = instance.getName() + <span class="jxr_string">"."</span> + sf.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 		<strong class="jxr_keyword">for</strong> (ValueSpecification value : slot.getValues()) {
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 			<em class="jxr_comment">// only set value, if not null</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 			<strong class="jxr_keyword">if</strong> (value.stringValue() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 				m_initCodeCConfig += varName + <span class="jxr_string">" = "</span> + value.stringValue() + EOL; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 			}
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 		}
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 	}
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L274" href="#L274">274</a> <em class="jxr_javadoccomment">	 * add the initialize operation. Must be called after a set of addInstance invocations</em>
<a class="jxr_linenumber" name="L275" href="#L275">275</a> <em class="jxr_javadoccomment">	 * @param language programming language to use (in the opaque behavior creation)</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> addInit(String language) {
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 		Operation initOp = m_bootLoader.getOwnedOperation(INIT_OP, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		OpaqueBehavior initBehavior = (OpaqueBehavior)
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 				m_bootLoader.createOwnedBehavior(initOp.getName(), UMLPackage.eINSTANCE.getOpaqueBehavior());
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 		initOp.getMethods().add(initBehavior);
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 		String code = m_initCode;
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 		<strong class="jxr_keyword">if</strong> (m_initCodeCConfig.length() &gt; 0) {
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 			code += m_initCodeCConfig;
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		}
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 		<strong class="jxr_keyword">if</strong> (m_initCodeCConnections.length() &gt; 0) {
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 			code += m_initCodeCConnections;
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 		}
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		Comparator&lt;Class&gt; comparator = <strong class="jxr_keyword">new</strong> Comparator&lt;Class&gt;() {
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 			@Override
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> compare(Class clazz1, Class clazz2) {
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 				InitPrecedence precedenceC1 = UMLUtil.getStereotypeApplication(clazz1, InitPrecedence.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 				InitPrecedence precedenceC2 = UMLUtil.getStereotypeApplication(clazz2, InitPrecedence.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 				<strong class="jxr_keyword">if</strong> (precedenceC1 != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 					<em class="jxr_comment">// need to use named comparison instead of precedenceC1.getInvokeAfter ().contains (clazz2)</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 					<em class="jxr_comment">// since class referenced by stereotype attribute still points to element in source model</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 					<strong class="jxr_keyword">if</strong> (ElementUtils.getNamedElementFromList(precedenceC1.getInvokeAfter(), clazz2.getName()) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 						<strong class="jxr_keyword">return</strong> 1;
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 					}
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 					<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ElementUtils.getNamedElementFromList(precedenceC1.getInvokeBefore(), clazz2.getName()) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 						<strong class="jxr_keyword">return</strong> -1;
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 					}
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 				}
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 				<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (precedenceC2 != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 					<strong class="jxr_keyword">if</strong> (ElementUtils.getNamedElementFromList(precedenceC2.getInvokeAfter(), clazz1.getName()) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 						<strong class="jxr_keyword">return</strong> -1;
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 					}
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 					<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ElementUtils.getNamedElementFromList(precedenceC2.getInvokeBefore(), clazz1.getName()) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 						<strong class="jxr_keyword">return</strong> 1;
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 					}
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 				}
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 				<em class="jxr_comment">// singletons have precedence over "normal" classes</em>
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 				<strong class="jxr_keyword">boolean</strong> ci1IsSingleton = DepUtils.isSingleton(clazz1);
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 				<strong class="jxr_keyword">boolean</strong> ci2IsSingleton = DepUtils.isSingleton(clazz2);
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 				<strong class="jxr_keyword">if</strong> (ci1IsSingleton) {
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 					<strong class="jxr_keyword">if</strong> (!ci2IsSingleton) {
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 						<em class="jxr_comment">// not both are singletons</em>
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 						<strong class="jxr_keyword">return</strong> -1;
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 					}
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 				}
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 				<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ci2IsSingleton) {
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 					<strong class="jxr_keyword">return</strong> 1;
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 				}
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 				<strong class="jxr_keyword">return</strong> 0;
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 			}
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 		};
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		Class[] activationKeys = m_activation.keySet().toArray(<strong class="jxr_keyword">new</strong> Class[0]);
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 		<strong class="jxr_keyword">if</strong> (activationKeys.length &gt; 0) {
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 			Arrays.sort(activationKeys, comparator);
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 			code += languageActivation(activationKeys);
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 		}
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 		
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 		<strong class="jxr_keyword">if</strong> (m_initCodeRun != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 			code += m_initCodeRun;
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 		}
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 			code += languageDefaultExecCode();
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		}
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 		
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 		<strong class="jxr_keyword">if</strong> (activationKeys.length &gt; 0) {
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 			code += languageDeactivation(activationKeys);
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 		}
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 		initBehavior.getLanguages().add(language);
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		initBehavior.getBodies().add(code);
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 	}
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L354" href="#L354">354</a> <em class="jxr_javadoccomment">	 * Normally, a composite instantiates its children. However, we want to enable the possibility</em>
<a class="jxr_linenumber" name="L355" href="#L355">355</a> <em class="jxr_javadoccomment">	 * to type a part in a composite with an abstract class and choose the concrete implementation</em>
<a class="jxr_linenumber" name="L356" href="#L356">356</a> <em class="jxr_javadoccomment">	 * in the moment of the deployment. In this case, the bootloader needs to perform the instantiation. </em>
<a class="jxr_linenumber" name="L357" href="#L357">357</a> <em class="jxr_javadoccomment">	 * @param structuralFeature a structural feature in a composition (typically an attribute)</em>
<a class="jxr_linenumber" name="L358" href="#L358">358</a> <em class="jxr_javadoccomment">	 * @return true, if the boot loader should instantiate the associated component.</em>
<a class="jxr_linenumber" name="L359" href="#L359">359</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> instantiateViaBootloader(StructuralFeature structuralFeature) {
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 		<strong class="jxr_keyword">if</strong> (structuralFeature.getType() instanceof Classifier) {
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 			<strong class="jxr_keyword">return</strong> ((Classifier) structuralFeature.getType()).isAbstract();
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 		}
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 		<em class="jxr_comment">// should not happen (all UML types are classifiers)</em>
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 	}
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 	<strong class="jxr_keyword">public</strong> Class getUML() {
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 		<strong class="jxr_keyword">return</strong> m_bootLoader;
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 	}
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 	<strong class="jxr_keyword">protected</strong> Class m_bootLoader;
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L375" href="#L375">375</a> <em class="jxr_javadoccomment">	 * Initialization code, in particular assignment of part properties within composites</em>
<a class="jxr_linenumber" name="L376" href="#L376">376</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 	<strong class="jxr_keyword">protected</strong> String m_initCode;
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L380" href="#L380">380</a> <em class="jxr_javadoccomment">	 * Init code for create connections calls in composites with at least one assembly</em>
<a class="jxr_linenumber" name="L381" href="#L381">381</a> <em class="jxr_javadoccomment">	 * connector</em>
<a class="jxr_linenumber" name="L382" href="#L382">382</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 	<strong class="jxr_keyword">protected</strong> String m_initCodeCConfig;
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L386" href="#L386">386</a> <em class="jxr_javadoccomment">	 * Init code for create connections calls in composites with at least one assembly</em>
<a class="jxr_linenumber" name="L387" href="#L387">387</a> <em class="jxr_javadoccomment">	 * connector</em>
<a class="jxr_linenumber" name="L388" href="#L388">388</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 	<strong class="jxr_keyword">protected</strong> String m_initCodeCConnections;
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L392" href="#L392">392</a> <em class="jxr_javadoccomment">	 * Init code for blocking "run" calls (related to CStart system component)</em>
<a class="jxr_linenumber" name="L393" href="#L393">393</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 	<strong class="jxr_keyword">protected</strong> String m_initCodeRun;
<a class="jxr_linenumber" name="L395" href="#L395">395</a> 
<a class="jxr_linenumber" name="L396" href="#L396">396</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L397" href="#L397">397</a> <em class="jxr_javadoccomment">	 * Map containing activations/de-activations</em>
<a class="jxr_linenumber" name="L398" href="#L398">398</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L399" href="#L399">399</a> 	<strong class="jxr_keyword">protected</strong> Map&lt;Class, EList&lt;String&gt;&gt; m_activation;
<a class="jxr_linenumber" name="L400" href="#L400">400</a> 
<a class="jxr_linenumber" name="L401" href="#L401">401</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> outputSizeof;
<a class="jxr_linenumber" name="L402" href="#L402">402</a> 
<a class="jxr_linenumber" name="L403" href="#L403">403</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L404" href="#L404">404</a> <em class="jxr_javadoccomment">	 * copier variable (instances still point to non-copied classes)</em>
<a class="jxr_linenumber" name="L405" href="#L405">405</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L406" href="#L406">406</a> 	<strong class="jxr_keyword">protected</strong> LazyCopier m_copier;
<a class="jxr_linenumber" name="L407" href="#L407">407</a> 
<a class="jxr_linenumber" name="L408" href="#L408">408</a> 	<strong class="jxr_keyword">public</strong> Property addInstance(Stack&lt;Slot&gt; slotPath, InstanceSpecification instance, Class implementation)
<a class="jxr_linenumber" name="L409" href="#L409">409</a> 			<strong class="jxr_keyword">throws</strong> TransformationException
<a class="jxr_linenumber" name="L410" href="#L410">410</a> 	{
<a class="jxr_linenumber" name="L411" href="#L411">411</a> 		<em class="jxr_comment">// TODO: comments not clear. seems unnecessary complex. Problem in general is that access to</em>
<a class="jxr_linenumber" name="L412" href="#L412">412</a> 		<em class="jxr_comment">// shared instances needs to be configured.</em>
<a class="jxr_linenumber" name="L413" href="#L413">413</a> 		<em class="jxr_comment">// It should always be possible to configure this instance via a path w/o sharing.</em>
<a class="jxr_linenumber" name="L414" href="#L414">414</a> 		String accessName = getPath(slotPath, instance, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L415" href="#L415">415</a> 		<strong class="jxr_keyword">final</strong> String varName = getPath(slotPath, instance, false);
<a class="jxr_linenumber" name="L416" href="#L416">416</a> 
<a class="jxr_linenumber" name="L417" href="#L417">417</a> 		Property implemPart = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L418" href="#L418">418</a> 
<a class="jxr_linenumber" name="L419" href="#L419">419</a> 		<em class="jxr_comment">// containing instance not null (=&gt; neither main instance nor singleton)</em>
<a class="jxr_linenumber" name="L420" href="#L420">420</a> 		Slot containerSlot = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L421" href="#L421">421</a> 		<strong class="jxr_keyword">if</strong> (slotPath.size() &gt; 0) {
<a class="jxr_linenumber" name="L422" href="#L422">422</a> 			containerSlot = slotPath.peek();
<a class="jxr_linenumber" name="L423" href="#L423">423</a> 
<a class="jxr_linenumber" name="L424" href="#L424">424</a> 			<em class="jxr_comment">// initialize part/property in containing instance. The containing instance itself is accessed</em>
<a class="jxr_linenumber" name="L425" href="#L425">425</a> 			<em class="jxr_comment">// via the naming of the associated instance, the part itself via the name of the defining feature.</em>
<a class="jxr_linenumber" name="L426" href="#L426">426</a> 			<strong class="jxr_keyword">if</strong> (DepUtils.isShared(containerSlot)) {
<a class="jxr_linenumber" name="L427" href="#L427">427</a> 				<em class="jxr_comment">// we need to initialize the property (a reference) with the given instance</em>
<a class="jxr_linenumber" name="L428" href="#L428">428</a> 				Stack&lt;Slot&gt; referencePath = DepUtils.getAccessPath(instance);
<a class="jxr_linenumber" name="L429" href="#L429">429</a> 				<strong class="jxr_keyword">final</strong> String referenceVarName = getPath(referencePath, instance, false);
<a class="jxr_linenumber" name="L430" href="#L430">430</a> 
<a class="jxr_linenumber" name="L431" href="#L431">431</a> 				<em class="jxr_comment">// add code for initialization</em>
<a class="jxr_linenumber" name="L432" href="#L432">432</a> 				m_initCode += languageAssignRef(accessName, referenceVarName);
<a class="jxr_linenumber" name="L433" href="#L433">433</a> 						
<a class="jxr_linenumber" name="L434" href="#L434">434</a> 				<em class="jxr_comment">// is a reference which should not be called via activation &amp; start</em>
<a class="jxr_linenumber" name="L435" href="#L435">435</a> 				<em class="jxr_comment">// return now and skip code below</em>
<a class="jxr_linenumber" name="L436" href="#L436">436</a> 				<strong class="jxr_keyword">return</strong> implemPart;
<a class="jxr_linenumber" name="L437" href="#L437">437</a> 			}
<a class="jxr_linenumber" name="L438" href="#L438">438</a> 			<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (instantiateViaBootloader(containerSlot.getDefiningFeature())) {
<a class="jxr_linenumber" name="L439" href="#L439">439</a> 				<em class="jxr_comment">// let bootloader instantiate</em>
<a class="jxr_linenumber" name="L440" href="#L440">440</a> 				implemPart = m_bootLoader.createOwnedAttribute(<em class="jxr_comment">/* "i_" + */</em>varName, implementation);
<a class="jxr_linenumber" name="L441" href="#L441">441</a> 				<em class="jxr_comment">// add code for initialization (TODO: specific to C++!)</em>
<a class="jxr_linenumber" name="L442" href="#L442">442</a> 				m_initCode += accessName + <span class="jxr_string">" = &amp;"</span> + varName + EOL; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L443" href="#L443">443</a> 				implemPart.setIsComposite(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L444" href="#L444">444</a> 			}
<a class="jxr_linenumber" name="L445" href="#L445">445</a> 		}
<a class="jxr_linenumber" name="L446" href="#L446">446</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L447" href="#L447">447</a> 			<em class="jxr_comment">// top level instance =&gt; bootloader instantiates, create attribute</em>
<a class="jxr_linenumber" name="L448" href="#L448">448</a> 			implemPart = m_bootLoader.createOwnedAttribute(<em class="jxr_comment">/* "i_" + */</em>varName, implementation);
<a class="jxr_linenumber" name="L449" href="#L449">449</a> 			implemPart.setIsComposite(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L450" href="#L450">450</a> 			<em class="jxr_comment">// depending on the programming language, the created attribute is a reference and additional</em>
<a class="jxr_linenumber" name="L451" href="#L451">451</a> 			<em class="jxr_comment">// code is required to create the instance</em>
<a class="jxr_linenumber" name="L452" href="#L452">452</a> 			m_initCode += languageCreateInstance(instance, implementation);
<a class="jxr_linenumber" name="L453" href="#L453">453</a> 		}
<a class="jxr_linenumber" name="L454" href="#L454">454</a> 		<strong class="jxr_keyword">if</strong> (outputSizeof) {
<a class="jxr_linenumber" name="L455" href="#L455">455</a> 			<em class="jxr_comment">// TODO - specific for C++</em>
<a class="jxr_linenumber" name="L456" href="#L456">456</a> 			m_initCode += <span class="jxr_string">"cout &lt;&lt; \&quot;sizeof "</span> + implementation.getName() + <span class="jxr_string">": \&quot; &lt;&lt; sizeof ("</span> + varName + <span class="jxr_string">") &lt;&lt; endl;"</span> + EOL; <em class="jxr_comment">//$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$</em>
<a class="jxr_linenumber" name="L457" href="#L457">457</a> 		}
<a class="jxr_linenumber" name="L458" href="#L458">458</a> 
<a class="jxr_linenumber" name="L459" href="#L459">459</a> 		<em class="jxr_comment">// Need to check whether implementation is an executor which is encapsulated in a container. In this case, only</em>
<a class="jxr_linenumber" name="L460" href="#L460">460</a> 		<em class="jxr_comment">// the method of the container and not the method of the executor (which owns the same port) maybe called.</em>
<a class="jxr_linenumber" name="L461" href="#L461">461</a> 		<em class="jxr_comment">// Currently, this check is based on the use of "executor" as reserved part name (validation checks that the</em>
<a class="jxr_linenumber" name="L462" href="#L462">462</a> 		<em class="jxr_comment">// user does not use this name for application components)</em>
<a class="jxr_linenumber" name="L463" href="#L463">463</a> 		<strong class="jxr_keyword">boolean</strong> unconnectedStart = hasUnconnectedStartRoutine(m_copier, implementation, containerSlot);
<a class="jxr_linenumber" name="L464" href="#L464">464</a> 		<strong class="jxr_keyword">boolean</strong> implementsIStart = implementsIStart(implementation);
<a class="jxr_linenumber" name="L465" href="#L465">465</a> 		<strong class="jxr_keyword">if</strong> (unconnectedStart || implementsIStart) {
<a class="jxr_linenumber" name="L466" href="#L466">466</a> 			<em class="jxr_comment">// check if already assigned earlier</em>
<a class="jxr_linenumber" name="L467" href="#L467">467</a> 			<strong class="jxr_keyword">if</strong> (m_initCodeRun.equals(EMPTYSTR)) {
<a class="jxr_linenumber" name="L468" href="#L468">468</a> 				<em class="jxr_comment">// call start's run method</em>
<a class="jxr_linenumber" name="L469" href="#L469">469</a> 				<em class="jxr_comment">// TODO: Need path that uses the right dereference operator ("-&gt;" or ".")</em>
<a class="jxr_linenumber" name="L470" href="#L470">470</a> 				m_initCodeRun = languageRunStart(varName, implementsIStart);
<a class="jxr_linenumber" name="L471" href="#L471">471</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L472" href="#L472">472</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> TransformationException(String.format(
<a class="jxr_linenumber" name="L473" href="#L473">473</a> 						Messages.BootLoaderGen_AtLeastOneBlockingCall,
<a class="jxr_linenumber" name="L474" href="#L474">474</a> 						varName, m_initCodeRun));
<a class="jxr_linenumber" name="L475" href="#L475">475</a> 			}
<a class="jxr_linenumber" name="L476" href="#L476">476</a> 		}
<a class="jxr_linenumber" name="L477" href="#L477">477</a> 		<strong class="jxr_keyword">if</strong> (hasUnconnectedLifeCycle(m_copier, implementation, containerSlot)) {
<a class="jxr_linenumber" name="L478" href="#L478">478</a> 			<em class="jxr_comment">// precedence is checked below (when code is actually produced)</em>
<a class="jxr_linenumber" name="L479" href="#L479">479</a> 			<em class="jxr_comment">// multiple varNames might share the same implementation. Put a list of variable names into the table</em>
<a class="jxr_linenumber" name="L480" href="#L480">480</a> 			EList&lt;String&gt; varNameList = m_activation.get(implementation);
<a class="jxr_linenumber" name="L481" href="#L481">481</a> 			<strong class="jxr_keyword">if</strong> (varNameList == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L482" href="#L482">482</a> 				varNameList = <strong class="jxr_keyword">new</strong> BasicEList&lt;String&gt;();
<a class="jxr_linenumber" name="L483" href="#L483">483</a> 			}
<a class="jxr_linenumber" name="L484" href="#L484">484</a> 			varNameList.add(varName + <span class="jxr_string">"."</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L485" href="#L485">485</a> 			m_activation.put(implementation, varNameList);
<a class="jxr_linenumber" name="L486" href="#L486">486</a> 		}
<a class="jxr_linenumber" name="L487" href="#L487">487</a> 
<a class="jxr_linenumber" name="L488" href="#L488">488</a> 		<em class="jxr_comment">// check, if implementation contains a composite with assembly connectors</em>
<a class="jxr_linenumber" name="L489" href="#L489">489</a> 		<strong class="jxr_keyword">for</strong> (Connector connector : implementation.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L490" href="#L490">490</a> 			<strong class="jxr_keyword">if</strong> (ConnectorUtil.isAssembly(connector)) {
<a class="jxr_linenumber" name="L491" href="#L491">491</a> 				m_initCodeCConnections += languageCreateConn(varName);
<a class="jxr_linenumber" name="L492" href="#L492">492</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L493" href="#L493">493</a> 			}
<a class="jxr_linenumber" name="L494" href="#L494">494</a> 		}
<a class="jxr_linenumber" name="L495" href="#L495">495</a> 
<a class="jxr_linenumber" name="L496" href="#L496">496</a> 		<strong class="jxr_keyword">return</strong> implemPart;
<a class="jxr_linenumber" name="L497" href="#L497">497</a> 	}
<a class="jxr_linenumber" name="L498" href="#L498">498</a> 	
<a class="jxr_linenumber" name="L499" href="#L499">499</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> addInstance(InstanceSpecification is, Stack&lt;Slot&gt; slotPath) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L500" href="#L500">500</a> 		Classifier implementation = DepUtils.getClassifier(is);
<a class="jxr_linenumber" name="L501" href="#L501">501</a> 		<strong class="jxr_keyword">if</strong> (implementation instanceof Class) {
<a class="jxr_linenumber" name="L502" href="#L502">502</a> 			addInstance(slotPath, is, (Class) implementation);
<a class="jxr_linenumber" name="L503" href="#L503">503</a> 		}
<a class="jxr_linenumber" name="L504" href="#L504">504</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : is.getSlots()) {
<a class="jxr_linenumber" name="L505" href="#L505">505</a> 			InstanceSpecification subIS = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L506" href="#L506">506</a> 			slotPath.push(slot);
<a class="jxr_linenumber" name="L507" href="#L507">507</a> 			<strong class="jxr_keyword">if</strong> (subIS != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L508" href="#L508">508</a> 				addInstance(subIS, slotPath);
<a class="jxr_linenumber" name="L509" href="#L509">509</a> 			}
<a class="jxr_linenumber" name="L510" href="#L510">510</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L511" href="#L511">511</a> 				instanceConfig(slotPath, is);
<a class="jxr_linenumber" name="L512" href="#L512">512</a> 			}
<a class="jxr_linenumber" name="L513" href="#L513">513</a> 			slotPath.pop();	
<a class="jxr_linenumber" name="L514" href="#L514">514</a> 		}
<a class="jxr_linenumber" name="L515" href="#L515">515</a> 	}
<a class="jxr_linenumber" name="L516" href="#L516">516</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
